From 265d4b017529c9bdc21ecdbf7fe4794789260545 Mon Sep 17 00:00:00 2001
From: Boris Mironov <boris.mironov@gmail.com>
Date: Sun, 1 Mar 2026 19:06:45 +0700
Subject: [PATCH v9 26/26] Added more tests

---
 src/bin/pgbench/t/001_pgbench_with_server.pl | 98 ++++++++++++++++++++
 1 file changed, 98 insertions(+)

diff --git a/src/bin/pgbench/t/001_pgbench_with_server.pl b/src/bin/pgbench/t/001_pgbench_with_server.pl
index 46569b0eb37..73d2d754273 100644
--- a/src/bin/pgbench/t/001_pgbench_with_server.pl
+++ b/src/bin/pgbench/t/001_pgbench_with_server.pl
@@ -172,6 +172,53 @@ $node->pgbench(
 check_data_state($node, 'server-side');
 
 
+# Test server-side generation with generate_series
+$node->pgbench(
+	'--initialize --init-steps=dtG',
+	0,
+	[qr{^$}],
+	[
+		qr{dropping old tables},
+		qr{creating tables},
+		qr{generating data \(server-side as single transaction\)},
+		qr{done in \d+\.\d\d s }
+	],
+	'pgbench --init-steps server-side generate_series');
+
+# Check data state, after server-side data generation.
+check_data_state($node, 'server-side (generate_series)');
+
+$node->pgbench(
+	'--initialize --init-steps=dtSG',
+	0,
+	[qr{^$}],
+	[
+		qr{dropping old tables},
+		qr{creating tables},
+		qr{generating data \(server-side as single transaction\)},
+		qr{done in \d+\.\d\d s }
+	],
+	'pgbench --init-steps server-side generate_series');
+
+# Check data state, after server-side data generation.
+check_data_state($node, 'server-side (generate_series single XACT)');
+
+$node->pgbench(
+	'--initialize --init-steps=dtMG',
+	0,
+	[qr{^$}],
+	[
+		qr{dropping old tables},
+		qr{creating tables},
+		qr{generating data \(server-side as multiple transactions\)},
+		qr{done in \d+\.\d\d s }
+	],
+	'pgbench --init-steps server-side generate_series');
+
+# Check data state, after server-side data generation.
+check_data_state($node, 'server-side (generate_series multiple XACTs)');
+
+
 # Test server-side generation with UNNEST
 $node->pgbench(
 	'--initialize --init-steps=dtU',
@@ -188,6 +235,36 @@ $node->pgbench(
 # Check data state, after server-side data generation.
 check_data_state($node, 'server-side (unnest)');
 
+$node->pgbench(
+	'--initialize --init-steps=dtSU',
+	0,
+	[qr{^$}],
+	[
+		qr{dropping old tables},
+		qr{creating tables},
+		qr{generating data \(server-side as single transaction\)},
+		qr{done in \d+\.\d\d s }
+	],
+	'pgbench --init-steps server-side UNNEST');
+
+# Check data state, after server-side data generation.
+check_data_state($node, 'server-side (unnest)');
+
+$node->pgbench(
+	'--initialize --init-steps=dtMU',
+	0,
+	[qr{^$}],
+	[
+		qr{dropping old tables},
+		qr{creating tables},
+		qr{generating data \(server-side as multiple transactions\)},
+		qr{done in \d+\.\d\d s }
+	],
+	'pgbench --init-steps server-side UNNEST');
+
+# Check data state, after server-side data generation.
+check_data_state($node, 'server-side (unnest)');
+
 
 # Test client-side generation with COPY TEXT
 $node->pgbench(
@@ -286,6 +363,27 @@ $node->pgbench(
 check_data_state($node, 'client-side (binary)');
 
 
+# Check data state, after different modes of client-side data generation.
+check_data_state($node, 'client-side (binary)');
+
+$node->pgbench(
+	'--initialize --init-steps=dtMccSc',
+	0,
+	[qr{^$}],
+	[
+		qr{dropping old tables},
+		qr{creating tables},
+		qr{generating data \(client-side as multiple transactions},
+		qr{generating data \(client-side as multiple transactions},
+		qr{generating data \(client-side as single transaction},
+		qr{done in \d+\.\d\d s }
+	],
+	'pgbench --init-steps client-side BINARY (multiple XACT modes)');
+
+# Check data state, after client-side data generation.
+check_data_state($node, 'client-side (binary different XACT modes in list of --init-steps)');
+
+
 # Run all builtin scripts, for a few transactions each
 $node->pgbench(
 	'--transactions=5 -Dfoo=bla --client=2 --protocol=simple --builtin=t'
-- 
2.43.0

